# -*- coding: utf-8 -*-


#  tests de fiabilité du sudoku

def test_ligne(s, i):
    '''
    teste les doublons
    dans la ligne i du sudoku s
    renvoie True s'il y a au moins un doublon
    '''
    L = [1 for i in range(9)]
    # à remplir
    return False  # ou pas, à vous de voir


def test_colonne(s, j):
    '''
    teste les doublons
    dans la ligne i du sudoku s
    renvoie True s'il y a au moins un doublon
    '''
    L = [1 for i in range(9)]
    # à remplir
    return False


def test_carre(s, i, j):
    '''
    teste les doublons
    dans le tableau 3x3 de coordonnées (i,j) du sudoku s
    renvoie True s'il y a au moins un doublon
    '''
    # à remplir
    return False


def fiable(s):
    '''
    teste si le sudoku n'a pas de chiffre redondant
    renvoie True si tout va bien
    '''

    pass  # à remplir
    return True


def chiffre_barre_ligne(s, L, i):
    '''
    met 0 (= barre le chiffre)
    dans le tableau de chiffres L
    pour tous les chiffres déjà utilisés
    dans la ligne i du sudoku s
    '''
    return L


def chiffre_barre_colonne(s, L, j):
    '''
    met 0 (= barre le chiffre)
    dans le tableau de chiffres L
    pour tous les chiffres déjà utilisés
    dans la colonne j du sudoku s
    '''
    return L


def chiffre_barre_carre(s, L, i, j):
    '''
    met 0 (= barre le chiffre)
    dans le tableau de chiffres L
    pour tous les chiffres déjà utilisés
    dans le tableau 3x3 de coordonnées (i,j) du sudoku s
    '''
    pass  # à effacer pour remplir la fonction


def nombre_possible(s, i, j):
    '''
    renvoie une liste L de 9 éléments où
    L[k] = 1 si k n'est pas encore utilisé dans le sudoku s
    au niveau de la ligne, de la colonne et du tableau 3x3
    correspondant au point (i, j)
    '''
    L = [1 for i in range(9)]
    pass  # à remplir
    return L


def score(L):
    """
    Retourne le score associé à la liste L
    """
    return -1


def meilleure_case(s):
    '''
    renvoie imin,jmin et L (liste de chiffres pris)
    de la meilleur case (celle de d min)
    '''
    scoremin = 10  # soit l'infini car > 9
    imin = -1
    jmin = -1
    Lmin = []
    # trouver la case de score minimum

    return imin, jmin, Lmin


def resolution(s):
    '''
    résout le sudoku
    renvoie 0 quand il y a échec
            -1 quand le sudoku est déjà rempli au départ ou bien sudoku faux
            1 quand il vient de réussir à le remplir
    '''
    imin, jmin, rmin = meilleure_case(s)

    if imin == -1:  # tout est rempli
        return -1  # sudoku déjà complet

    d = sum(rmin)
    if d == 0:
        return 0
    else:  # if d > 1:
        for n in range(9):
            if rmin[n] == 1:  # si n+1 est libre on remplit et on cherche...
                s[imin][jmin] = n+1
                a = resolution(s)
                if a == 0:  # échec
                    s[imin][jmin] = 0
                else:
                    return 1  # réussite
        return 0  # échec


if __name__ == '__main__':

    # Le Monde 5 mars 2014 sudoku facile n°14-054
    grille = [[0, 0, 0, 7, 1, 0, 0, 0, 0],
              [0, 0, 8, 0, 6, 0, 3, 0, 0],
              [0, 0, 0, 0, 5, 0, 0, 4, 0],
              [6, 8, 0, 0, 0, 0, 0, 0, 2],
              [3, 0, 9, 0, 2, 6, 0, 0, 0],
              [0, 0, 0, 0, 0, 9, 0, 5, 7],
              [8, 1, 0, 4, 0, 3, 0, 0, 0],
              [4, 9, 0, 0, 0, 0, 2, 0, 8],
              [7, 5, 0, 0, 8, 0, 4, 0, 3]]

    # affiche le sudoku
    for i in range(9):
        print(grille[i])

    if fiable(grille):
        print('Pas de problème détecté sur le sudoku')

    print(resolution(grille))

    for i in range(9):
        print(grille[i])
